
#ifndef PEER_INFO_H
#define PEER_INFO_H

#include "types.h"

struct peer_info {
  struct allnet_peer peer;
  time_t last_sent;       /* set to zero if never sent to them */
  time_t last_received;   /* set to zero if never received from them */
};
#define SAVED_PEERS     100  /* maximum saved */
#define SENT_PEERS      5    /* maximum in hello message and broadcast */

/* number of peers available */
extern int stored_peers ();

/* if the peer is already saved, does nothing */ 
extern void add_peer (struct allnet_peer * peer);

/* record that a hello was just received from this peer */
extern void received_now (struct allnet_peer * peer);

/* returns the number of peers placed into *peer, which will not
 * in any case exceed max_peers, but may be fewer
 *
 * if must_be_ip, only peers with IP addresses (v4 or v6) are returned.
 * if seconds_since_last_sent > 0, only peers with last_sent > the parameter
 * are returned, and their send time is updated to now
 */
extern int random_peers (struct peer_info * peer, int max_peers,
                         int must_be_ip, int seconds_since_last_sent);



#endif /* PEER_INFO_H */
